<?php
	error_reporting(1);
	ini_set('display_errors', 1);
	$servertimezone = 'Europe/Chisinau';
	date_default_timezone_set($servertimezone);
	session_start();
	require_once 'core/config/mysql.config.php';
	require_once('core/engine.php');
	$engine_session = new engine();
	require_once('core/template.php');
	$template_session = new template();
	if(ADMIN==1)  
	{
		require_once('administration/admin.php');
		$admin_session = new admin();
	}
	define("IMG_PATH", "../../media/images/users/");
	define("GIFTS_IMG_PATH", "../media/images/gifts/");
	define("STICKERS_IMG_PATH", "../media/images/stickers/");
	define("USER_ID", $_SESSION['id']);
	define("USER_USERNAME", $_SESSION['account_username']);
	define("USER_RIGHTS", $_SESSION['__rights']);
	define("USER_RANK", $_SESSION['rank']);
	define("USER_IP", getenv("REMOTE_ADDR"), true);
	define("SESSION_STATUS", $_SESSION['login']);
	define("SESSION_MESSAGE", $_SESSION['msg']);
	define("ANONYMOUS",getlanguage(82,1));
	define("SCRIPT_VERSION", "5.2");
	define("LICENCE", "http://xandr.me/portfolio/q2aphp");
	define("AUTHOR", "http://xandr.me/");

	$website = $engine_session->getinfo("*", 0);
	define("SITE_NAME", $website['website_name'], true);
	define("SITE_DOMAIN", $website['website_domain'], true);
	define("SITE_DESCRIPTION", $website['website_description'], true);
	define("SITE_KEYWORDS", $website['website_keywords'], true);
	define("SITE_MAINTENANCE", $website['website_maintenance'] , true);
	define("USER_ANONYM", $engine_session->getlangvar(82), true);

	$paypal = $engine_session->paypalinfo("*", 0);
	define("PAYMENT_ENABLED", $paypal['enabled'], true);
	define("PAYMENT_MODE", $paypal['pay_mode'], true);
	define("PAYMENT_APIUSERNAME", $paypal['apiusername'], true);
	define("PAYMENT_APIPASSWORD", $paypal['apipassword'], true);
	define("PAYMENT_APISIGNATURE", $paypal['apisignature'], true);
	define("PAYMENT_CURRENCYCODE", $paypal['currencycode'], true);
	define("PAYMENT_PRICE", $paypal['price'], true);

	define("Q_LENGTH", 400, true); // Question max length
	define("GET_FREE_POINTS", 1); // 1 to receive free points or 0 - not (One point per question, answer with 50% probability)
	define("GIFT_PRICE", 10); // Price for 1 gift in points
	define("PHOTO_MAX_SIZE", 5097152, true); // 5MB
	define("PHOTO_MAX_WIDTH", 5000, true); // 5000 Pixels
	define("PHOTO_MAX_HEIGHT", 5000, true); // 5000 Pixels

	if(USER_ID!="")
	{
		$engine_session->savevisit();
	}
	
	function counttime($date)
	{	
		$ndate = strtotime($date);
		$time = usertime(time());
		$time = strtotime($time);
		$time = $time - $ndate; 
		$tokens = array (
			86400 => ''.langVar(858).'',
			3600 => ''.langVar(857).'',
			60 => ''.langVar(856).'',
			1 => ''.langVar(855).''
		);
		if($time==0 || $time<4)
		{
			return ''.langVar(861).'';
		}
		elseif($time>3 && $time < 604800)
		{
			foreach ($tokens as $unit => $text) 
			{
				if ($time < $unit) continue;
				$numberOfUnits = floor($time / $unit);
				return $numberOfUnits.' '.$text.' '.langVar(859).'';
			}
		}
		else
		{
			return ''.langVar(860).' '.$date;
		}
	}
	
	function usertime($date)
	{	
		if($_SESSION['tzname']!="")
		{
			$tz = new DateTimeZone($_SESSION['tzname']);
		}
		else
		{
			$tz = new DateTimeZone($servertimezone);
		}
		$dtStr = date("c", $date);
		$date = new DateTime($dtStr);
		$date->setTimeZone($tz);
		return $date->format('d.m.Y H:i:s');	
	}	
	
	function txt2link($url)
	{
		$url = str_replace("\\r","\r",$url);
		$url = str_replace("\\n","\n<BR>",$url);
		$url = str_replace("\\n\\r","\n\r",$url);
		$in=array(
			'`((?:https?|ftp)://\S+[[:alnum:]]/?)`si',
			'`((?<!//)(www\.\S+[[:alnum:]]/?))`si'
		);
		$out=array(
			'<a href="$1"  rel=nofollow>$1</a> ',
			'<a href="http://$1" rel=\'nofollow\'>$1</a>'
		);
		return preg_replace($in,$out,$url);
	}
	
	function getsmiles($text)
	{
		$text = preg_replace("#]:\)#is","<img class='smile' src='media/images/smiles/12.gif' border='0' />",$text);
		$text = preg_replace("#:\)#is","<img class='smile' title='$1' src='media/images/smiles/1.gif'/>",$text);
		$text = preg_replace("#:\*#is","<img class='smile' src='media/images/smiles/2.gif' border='0' />",$text);
		$text = preg_replace("#\(:\|#is","<img class='smile' src='media/images/smiles/3.gif' border='0' />",$text);
		$text = preg_replace("#:\(#is","<img class='smile' src='media/images/smiles/4.gif' border='0' />",$text);
		$text = preg_replace("#-_#is","<img class='smile' src='media/images/smiles/5.gif' border='0' />",$text);
		$text = preg_replace("#:D#is","<img class='smile' src='media/images/smiles/6.gif' border='0' />",$text);
		$text = preg_replace("#\(o.o\)#is","<img class='smile' src='media/images/smiles/7.gif' border='0' />",$text);
		$text = preg_replace("#;\)#is","<img class='smile' src='media/images/smiles/8.gif' border='0' />",$text);
		$text = preg_replace("#:P#is","<img class='smile' src='media/images/smiles/9.gif' border='0' />",$text);
		$text = preg_replace("#\(:S\)#is","<img class='smile' src='media/images/smiles/10.gif' border='0' />",$text);
		$text = preg_replace("#\(8\)\)#is","<img class='smile' src='media/images/smiles/11.gif' border='0' />",$text);
		$text = preg_replace("#\(envy\)#is","<img class='smile' src='media/images/smiles/13.gif' border='0' />",$text);
		$text = preg_replace("#\(lol\)#is","<img class='smile' src='media/images/smiles/14.gif' border='0' />",$text);
		$text = preg_replace("#\(love\)#is","<img class='smile' src='media/images/smiles/15.gif' border='0' />",$text);
		$text = preg_replace("# :\/#is","<img class='smile' src='media/images/smiles/16.gif' border='0' />",$text);
		return $text;
	}

	function text_filter($text, $mode)
	{
		/* $mode = 1 - insert in database, 2 - read from database */
		if($mode==1) 
		{
			$text = preg_replace(sql_regcase("/(drop table|show tables|#|--|\\\\)/"),"",$text);
			$text = preg_replace("/(\<script)(.*?)(script>)/si", "", $text);
			$text = str_replace("<!--", "&lt;!--", $text);
			$text = mysql_real_escape_string($text);  
		}
		if($mode==2)
		{
			$text = nl2br(htmlentities($text, ENT_QUOTES));
		}
		return $text;
	}
	
	function langvar($varID)
	{
		global $template_session;
		if(isset($varID))
		{
			if(is_int($varID))
			{
				return $template_session->getlangvar($varID);
			}
		}
	}

	function getquestioncomments($questionID)
	{
		return mysql_num_rows(mysql_query('select * from comments where question_id = "'.$questionID.'" and alive = "1" ORDER BY id'));
	}
	
	function getlikes($id,$nr,$user,$type="1")
	{
		$message = "";
		$sqlquer = "SELECT * FROM likes WHERE q_id = ".$id."";
		$quer = mysql_query($sqlquer);
		$total = mysql_num_rows($quer);
		if($total != 0)
		{
			$sqlquery = "SELECT * FROM likes WHERE q_id = ".$id." ORDER BY id DESC limit 0, ".$nr."";
			$query = mysql_query($sqlquery);
			if(mysql_num_rows($query) != 0)
			{	
				$message .= "<div id='likesbox'><p id='countlike' style='float:right'><span class='countlike".$id."'>".$total."</span> ".langVar(805)."</span>";
				$message .=  "<span class='hoverlikes'>";
				while($ii = mysql_fetch_assoc($query))
				{	
					$c_id = $ii['id']; 
					$c_q_id = $ii['q_id']; 
					$c_user = $ii['user'];
					if($c_user==USER_USERNAME) $liked = true;
					$sqlgetphoto = mysql_query("SELECT photo FROM users WHERE username = '$c_user'");
					$iii = mysql_fetch_assoc($sqlgetphoto);
					if(file_exists('../../media/images/users/tt_'.$iii['photo'].''))
					{
						$message .= "<a href='http://".SITE_DOMAIN."/".$c_user."'><img src='media/images/users/tt_".$iii['photo']."'></a>";
					}
					else 
					{
						if(file_exists('../../media/images/users/'.$iii['photo'].''))
						{
							$message .= "<a href='http://".SITE_DOMAIN."/".$c_user."'><img src='media/images/users/".$iii['photo']."'></a>";
						}
						else 
						{
							$message .= "<a href='http://".SITE_DOMAIN."/".$c_user."'><img src='media/images/users/photo_default.png'></a>";
						}
					}
				}
					$message .=  "</span>";
				if($liked) $message .= "</p><div class='liked' ";
				else $message .= "</p><div class='like' ";
				if(SESSION_STATUS != false) 
				{
					$message .= "onclick='like($id)'";
				}
				$message .= "></div></div>";
			}
		}
		else
		{
			$message .= "<div id='likesbox'><div class='like' ";
			if(SESSION_STATUS != false) 
			{
				$message .= "onclick='like($id)'";
			}
			$message .= "></div><p id='countlike'><span class='countlike".$id."'>".$total."</span> ".langVar(805)."</p></div>";
		}
		if($type!=0)
		{
			$message .= '<div id="commentbox"><a href="http://'.SITE_DOMAIN.'/'.$user.'/q/'.$id.'" class="questionLink"><div class="commentsp"></div><p id=\'countlike\'>'.getquestioncomments($id).' '.langVar(406).'</p></a></div>';
		}
		return $message;
	}

	function getqa($user, $nr, $q)
	{	
		$message = '';
		if($q=='') $q=10;
		$sql = "SELECT * FROM questions WHERE to_user = '".$user."' AND status = '1' ORDER BY time DESC limit ".$nr.", ".$q."";
		$query = mysql_query($sql);
		$i=1;
		if (@mysql_num_rows($query) != 0)
		{
			while($ii = mysql_fetch_assoc($query))
			{
				$qa_id = $ii['id']; 
				$qa_to_user = $ii['from_user']; 
				$qa_question = txt2link(getsmiles($ii['question'])); 
				$qa_from_user = $ii['from_user']; 
				$qa_answer = txt2link(getsmiles($ii['answer'])); 
				$qa_image = $ii['image'];
				$qa_status = $ii['status']; 
				$qa_anonymous = $ii['anonymous']; 
				$qa_ip = $ii['ip']; 
				$qa_time = $ii['time']; 
				$sqlgetphoto = mysql_query("SELECT photo FROM users WHERE username = '$qa_to_user'");
					$iii = mysql_fetch_assoc($sqlgetphoto);
					if (!$iii['photo']) $iii['photo'] = "photo_anonymous.png";
				$message .= '<div class="question';
				if($i%2==0) $message .= ' questionbg';
				$i++;
				$message .= '" id="question'.$qa_id.'"><div id="questionimage">';
				if (file_exists('../../media/images/users/tt_'.$iii['photo'].''))
				{
					if($qa_anonymous!=1) $message .= "<a href=\"http://".SITE_DOMAIN."/".$qa_to_user."\">";
					$message .= '<div class="img imgLiquid" style="width:60px; height:60px">';
					$message .= "<img src=\"media/images/users/tt_".$iii['photo']."\" id=\"questionavatar\"/>";
					$message .= '</div>';
					if($qa_anonymous!=1)  $message .= "</a>";
					$message .= "</div>";
				}
				else 
				{
					if($qa_anonymous!=1) $message .= "<a href=\"http://".SITE_DOMAIN."/".$qa_to_user."\">";
					$message .= '<div class="img imgLiquid" style="width:60px; height:60px">';
					$message .= "<img src=\"media/images/users/".$iii['photo']."\" id=\"questionavatar\"/>";
					$message .= '</div>';
					if($qa_anonymous!=1)  $message .= "</a>";
					$message .= "</div>";
				}
				if($qa_anonymous!=1) $message .= '<div id="questionanswered"><b>'.$qa_to_user.'</b></div>'; 
				else $message .= '<div id="questionanswered"><b>'.langVar(878).'</b></div>'; 
				$message .= '<div id="questionbody"><h4>'.$qa_question.'</h4>'; 
				$message .= '<p>'.$qa_answer.'</p>';
				if ($qa_image!="")
				{
					$message .= '<a href="http://'.SITE_DOMAIN.'/image/'.$user.'/'.$qa_id.'"><img src="media/images/answers/'.$qa_image.'" width="300px"/></a>';
				}
				$message .= '</div>';
				$message .= '<div id="questionactions">';
				$message .= ''.getlikes($qa_id,8,$user,$qa_id).'';
				$message .= "<div class='clear'></div></div><div id=\"questionInfo\"><p>";
				$message .= counttime(usertime($qa_time));
				switch($qa_anonymous)
				{	case 0:	$message .= ' '.langVar(66).' <a href="http://'.SITE_DOMAIN.'/'.$qa_from_user.'">'.$qa_from_user.'</a>  ';
							break;
					case 1:	$message .= ' '.langVar(67).' '.langVar(82).'  ';
							break;
				}
				if ($user == USER_USERNAME && SESSION_STATUS != false)
				{	
					$message .= '<a href="delete/'.engine::crypts($qa_id, 2, 0).'" class="removeResponseLink" style="display:none">('.langVar(68).')</a>';
				}
				$message .= '</p></div></div>';
				$message .= '<div class="clear"></div>';
			}
		}
		echo $message;
	}
	
	function readparameter($value) 
	{
		echo (''.$value.''); 
	}

	function getlanguage($id, $return = 0)
	{
		global $template_session;
		$res = is_numeric($id) ? true : false; 
		if($res && $return == 0)
		{
			echo $template_session->getlangval($id);
		}
		elseif($res && $return != 0)
		{
			return $template_session->getlangval($id);
		}
	}

	function fakebooltoenum($bool)
	{
		if($bool == "true")
		{
			return 1;
		}
		return 0;
	}

	function checkuserloggedoff() 
	{	
		if(SESSION_STATUS != true) 
		{ 
			header('Location: http://'.SITE_DOMAIN.'/account/login');
		} 
	}

	function checkuserloggedin() 
	{	
		if(SESSION_STATUS != false) 
		{
			header('Location: http://'.SITE_DOMAIN.'/'.USER_USERNAME.'');
		} 
	}
	
	function gettopusers($numb, $type=0)
	{
		$message = '';
		$sqlquery = "SELECT username, points FROM `users` WHERE status != 1 AND photo NOT LIKE '%default%' ORDER BY points DESC LIMIT 0, $numb";
		$query = mysql_query($sqlquery);
		if(@mysql_num_rows($query) != 0)
		{	
			while($ii = @mysql_fetch_assoc($query))
			{	
				$loaduser = $ii['username'];
				$loadusersql = "SELECT * FROM users WHERE username='$loaduser'";
				$loaduserquery = mysql_query($loadusersql);
				if(@mysql_num_rows($loaduserquery) != 0)
				{
					while($iii = mysql_fetch_assoc($loaduserquery))
					{
						$Username = $iii['username'];
						$Image = $iii['photo'];
						$Points = $iii['points'];
						$message .= '<a href="http://'.SITE_DOMAIN.'/'.$Username.'"><div class="top resultLeft">';
						$message .= '<div class="profilePic">';
						if(file_exists('../../media/images/users/'.$iii['photo'].'') || file_exists('media/images/users/'.$iii['photo'].''))
						{
							$message .= '<div class="img imgLiquid" style="width:60px; height:60px;border-radius:5px">';
							$message .= '<img src="http://'.SITE_DOMAIN.'/media/images/users/'.$Image.'" alt="'.$Username.'"/>';
							$message .= '</div>';			
						}
						else 
						{
							if(file_exists('../../media/images/users/tt_'.$iii['photo'].'') || file_exists('media/images/users/tt_'.$iii['photo'].''))
							{
								
								$message .= '<div class="img imgLiquid" style="width:69px; height:69px;border-radius:5px">';
								$message .= '<img src="http://'.SITE_DOMAIN.'/media/images/users/tt_'.$Image.'" alt="'.$Username.'"/>';
								$message .= '</div>';
							}
							else
							{
								$message .= '<div class="img imgLiquid" style="width:69px; height:69px;border-radius:5px">';
								$message .= '<img src="http://'.SITE_DOMAIN.'/media/images/users/photo_default.png" alt="'.$Username.'"/>';
								$message .= '</div>';
							}
						}
						$message .= "</div>";
						$message .= '<div class="profile">';
						$message .= '<p class="points">'.$Points.'</p>';
						$message .= '<p class="name">'.$Username.'</p>';
						$message .= "</div>";
						$message .= '<div class="clear"></div>';
						$message .= "</div></a>";
					}
				}
			}
		}
		echo $message;
	}
	
	function getlastusers($numb)
	{
		$message = '';
		$sqlquery = "SELECT username, reg_date FROM `users` WHERE status != 1 AND photo NOT LIKE '%default%' ORDER BY visit DESC LIMIT 0, $numb";
		$query = mysql_query($sqlquery);
		if(mysql_num_rows($query) != 0)
		{	
			while($ii = @mysql_fetch_assoc($query))
			{	
				$loaduser = $ii['username'];
				$loadusersql = "SELECT * FROM users WHERE username='$loaduser'";
				$loaduserquery = mysql_query($loadusersql);
				if(@mysql_num_rows($loaduserquery) != 0)
				{
					while($iii = @mysql_fetch_assoc($loaduserquery))
					{
						$Username = $iii['username'];
						$Name = $iii['real_name'];
						$Surname = $iii['real_surname'];
						$Image = $iii['photo'];
						$message .= '<a href="http://'.SITE_DOMAIN.'/'.$Username.'"><div class="top resultLeft">';
						$message .= '<div class="profilePic">';
						if(file_exists('../../media/images/users/'.$iii['photo'].'') || file_exists('media/images/users/'.$iii['photo'].''))
						{
							$message .= '<img src="http://'.SITE_DOMAIN.'/media/images/users/'.$Image.'" alt="'.$Username.'"/>';
						}
						else 
						{
							if(file_exists('../../media/images/users/tt_'.$iii['photo'].'') || file_exists('media/images/users/tt_'.$iii['photo'].''))
							{
								$message .= '<img src="http://'.SITE_DOMAIN.'/media/images/users/tt_'.$Image.'" alt="'.$Username.'"/>';
							}
							else
							{
								$message .= '<img src="http://'.SITE_DOMAIN.'/media/images/users/photo_default.png" alt="'.$Username.'"/>';
							}
						}
						$message .= "</div>";
						$message .= '<div class="profile">';
						$message .= '<p class="points">'.$Points.'</p>';
						$message .= '<p class="name">'.$Username.'</p>';
						$message .= "</div>";
						$message .= '<div class="clear"></div>';
						$message .= "</div></a>";
					}
				}
			}
		}
		echo $message;
	}
	
	function homestream()
	{
		$message = "";
		$sql = "SELECT * FROM questions WHERE status='1' AND image='' ORDER BY STR_TO_DATE(date, '%d-%m-%Y') desc, time desc LIMIT 0, 4";
		$query = mysql_query($sql);
		if(@mysql_num_rows($query) != 0)
		{
			while($ii = mysql_fetch_assoc($query))
			{	
				$qa_id = $ii['id']; 
				$qa_to_user = $ii['to_user']; 
				$qa_question = txt2link(getsmiles($ii['question'])); 
				$qa_from_user = $ii['from_user']; 
				$qa_answer = txt2link(getsmiles($ii['answer'])); 
				$qa_status = $ii['status']; 
				$qa_anonymous = $ii['anonymous']; 
				$qa_date = $ii['date']; 
				$qa_time = $ii['time']; 
				$sqlgetphoto = mysql_query("SELECT photo FROM users WHERE username = '$qa_to_user'");
					$iii = mysql_fetch_assoc($sqlgetphoto);
					if(!$iii['photo']) $iii['photo'] = "photo_anonymous.png";
				$message .= "<a href=\"http://".SITE_DOMAIN."/".$qa_to_user."/q/".$qa_id."\">";
				$message .= "<div class=\"question\" id=\"question".$qa_id."\"><div id='questionimage'>";
				if(file_exists('../../media/images/users/tt_'.$iii['photo'].''))
				{
					$message .= "<img src=\"media/images/users/tt_".$iii['photo']."\" id=\"questionavatar\"/></div>";
				}
				else 
				{
					$message .= "<img src=\"media/images/users/".$iii['photo']."\" id=\"questionavatar\"/></div>";
				}
				$message .= '<div id="questionbody"><h4>'.$qa_question.'</h4>'; 
				$message .= '<p>'.htmlEncodeDecode($qa_answer, 1).'</p>';
				$message .= '</div>';
				$message .= "<div class='clear'></div></div></a>";
				$message .= '<div class="clear"></div>';
			}
		}
		echo $message;	
	}
?>